
#include "log.bi"
#include "chess.bi"
#include "uci.bi"

using uci

const VERSION = "0.2"
dim game as chess.TGame
dim as string s, ss(), fen

OpenLog(ExePath() & "\random.log")

with game
  .Initialize()
  .GenerateLegalMoves()
end with

Randomize(Timer)

do
  Sleep 10
  
  Input(s)
  ToLog(s)
  
  if IsCommandQuit(s) then
    exit do
  
  elseif IsCommandUCI(s) then
    Print("id name RANDOM " & VERSION)
    Print("id author Roland Chastain")
    Print("uciok")
  
  elseif IsCommandReady(s) then
    Print("readyok")
  
  elseif IsCommandNewGame(s)  then
    game.Initialize()
    game.GenerateLegalMoves()
  
  elseif IsCommandPosition(s) then
    
    if IsCommandStartPos(s) then
      game.Initialize()
    elseif IsCommandFEN(s) then
      if GetFEN(s, fen) then
        ToLog(fen)
        game.Initialize(fen)
      end if
    end if
    
    game.GenerateLegalMoves()
    
    if IsCommandMoves(s) then
      if GetMoves(s, ss()) then
        for i as integer = lbound(ss) to ubound(ss)
          ToLog(ss(i))
          if game.FindMove(left(ss(i), 4)) then
            game.DoMove(ss(i))
            game.GenerateLegalMoves()
          end if
        next i
      end if
    end if
  
  elseif IsCommandGo(s) then
    Print("bestmove " & game.RandomMove())
  end if
loop

CloseLog()
